
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Memory Access Patterns Are Important / iVAN</title>

    <meta name="description" content="Memory Access Patterns Are Important 原文地址:http://mechanical-sympathy.blogspot.com/2012/08/memory-access-patterns-are-important.html(因墙转载) In high-performance computing it is often said that the cost of a cache-miss is the largest performance penalty for an algorithm.  For many years the">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Memory Access Patterns Are Important</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>原文地址：<a href="http://mechanical-sympathy.blogspot.com/2012/08/memory-access-patterns-are-important.html" rel="external nofollow noreferrer">http://mechanical-sympathy.blogspot.com/2012/08/memory-access-patterns-are-important.html</a>（因墙转载）</p>
<p>In high-performance computing it is often said that the cost of a cache-miss is the largest performance penalty for an algorithm.  For many years the increase in speed of our processors has greatly outstripped latency gains to main-memory.  Bandwidth to main-memory has greatly increased via wider, and multi-channel, buses however the latency has not significantly reduced.  To hide this latency our processors employ evermore complex cache sub-systems that have many layers.</p>
<p>The 1994 paper “<a href="http://dl.acm.org/citation.cfm?id=216588" rel="external nofollow noreferrer">Hitting the memory wall: implications of the obvious</a>” describes the problem and goes on to argue that caches do not ultimately help because of compulsory cache-misses.  I aim to show that by using access patterns which display consideration for the cache hierarchy, this conclusion is not inevitable.</p>
<p>Let’s start putting the problem in context with some examples.  Our hardware tries to hide the main-memory latency via a number of techniques.  Basically three major bets are taken on memory access patterns:</p>
<ol>
<li><b>Temporal</b>: Memory accessed recently will likely be required again soon.</li>
<li><b>Spatial</b>: Adjacent memory is likely to be required soon.</li>
<li><b>Striding</b>: Memory access is likely to follow a predictable pattern.</li>
</ol>
<p>To illustrate these three bets in action let’s write some code and measure the results.</p>
<ol>
<li>Walk through memory in a linear fashion being completely predictable.</li>
<li>Pseudo randomly walk round memory within a restricted area then move on.  This restricted area is what is commonly known as an operating system <a href="http://en.wikipedia.org/wiki/Page_(computer_memory)" rel="external nofollow noreferrer">page</a> of memory.</li>
<li>Pseudo randomly walk around a large area of the heap.</li>
</ol>
<p><b>Code</b></p>
<p>The following code should be run with the <b>-Xmx4g</b> JVM option.</p>
<table>
<tbody>
<tr>
<td><code>001</code></td>
<td>
<code>public</code> <code>class</code> <code>TestMemoryAccessPatterns</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>002</code></td>
<td><code>{</code></td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>003</code></td>
<td>
<code>    </code><code>private</code> <code>static</code> <code>final</code> <code>int</code> <code>LONG_SIZE = </code><code>8</code><code>;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>004</code></td>
<td>
<code>    </code><code>private</code> <code>static</code> <code>final</code> <code>int</code> <code>PAGE_SIZE = </code><code>2</code> <code>* </code><code>1024</code> <code>* </code><code>1024</code><code>;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>005</code></td>
<td>
<code>    </code><code>private</code> <code>static</code> <code>final</code> <code>int</code> <code>ONE_GIG = </code><code>1024</code> <code>* </code><code>1024</code> <code>* </code><code>1024</code><code>;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>006</code></td>
<td>
<code>    </code><code>private</code> <code>static</code> <code>final</code> <code>long</code> <code>TWO_GIG = 2L * ONE_GIG;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>007</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>008</code></td>
<td>
<code>    </code><code>private</code> <code>static</code> <code>final</code> <code>int</code> <code>ARRAY_SIZE = (</code><code>int</code><code>)(TWO_GIG / LONG_SIZE);</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>009</code></td>
<td>
<code>    </code><code>private</code> <code>static</code> <code>final</code> <code>int</code> <code>WORDS_PER_PAGE = PAGE_SIZE / LONG_SIZE;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>010</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>011</code></td>
<td>
<code>    </code><code>private</code> <code>static</code> <code>final</code> <code>int</code> <code>ARRAY_MASK = ARRAY_SIZE - </code><code>1</code><code>;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>012</code></td>
<td>
<code>    </code><code>private</code> <code>static</code> <code>final</code> <code>int</code> <code>PAGE_MASK = WORDS_PER_PAGE - </code><code>1</code><code>;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>013</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>014</code></td>
<td>
<code>    </code><code>private</code> <code>static</code> <code>final</code> <code>int</code> <code>PRIME_INC = </code><code>514229</code><code>;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>015</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>016</code></td>
<td>
<code>    </code><code>private</code> <code>static</code> <code>final</code> <code>long</code><code>[] memory = </code><code>new</code> <code>long</code><code>[ARRAY_SIZE];</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>017</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>018</code></td>
<td>
<code>    </code><code>static</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>019</code></td>
<td>
<code>    </code><code>{</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>020</code></td>
<td>
<code>        </code><code>for</code> <code>(</code><code>int</code> <code>i = </code><code>0</code><code>; i &lt; ARRAY_SIZE; i++)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>021</code></td>
<td>
<code>        </code><code>{</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>022</code></td>
<td>
<code>            </code><code>memory[i] = </code><code>777</code><code>;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>023</code></td>
<td>
<code>        </code><code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>024</code></td>
<td>
<code>    </code><code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>025</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>026</code></td>
<td>
<code>    </code><code>public</code> <code>enum</code> <code>StrideType</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>027</code></td>
<td>
<code>    </code><code>{</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>028</code></td>
<td>
<code>        </code><code>LINEAR_WALK</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>029</code></td>
<td>
<code>        </code><code>{</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>030</code></td>
<td>
<code>            </code><code>public</code> <code>int</code> <code>next(</code><code>final</code> <code>int</code> <code>pageOffset, </code><code>final</code> <code>int</code> <code>wordOffset, </code><code>final</code> <code>int</code> <code>pos)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>031</code></td>
<td>
<code>            </code><code>{</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>032</code></td>
<td>
<code>                </code><code>return</code> <code>(pos + </code><code>1</code><code>) &amp; ARRAY_MASK;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>033</code></td>
<td>
<code>            </code><code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>034</code></td>
<td>
<code>        </code><code>},</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>035</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>036</code></td>
<td>
<code>        </code><code>RANDOM_PAGE_WALK</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>037</code></td>
<td>
<code>        </code><code>{</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>038</code></td>
<td>
<code>            </code><code>public</code> <code>int</code> <code>next(</code><code>final</code> <code>int</code> <code>pageOffset, </code><code>final</code> <code>int</code> <code>wordOffset, </code><code>final</code> <code>int</code> <code>pos)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>039</code></td>
<td>
<code>            </code><code>{</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>040</code></td>
<td>
<code>                </code><code>return</code> <code>pageOffset + ((pos + PRIME_INC) &amp; PAGE_MASK);</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>041</code></td>
<td>
<code>            </code><code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>042</code></td>
<td>
<code>        </code><code>},</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>043</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>044</code></td>
<td>
<code>        </code><code>RANDOM_HEAP_WALK</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>045</code></td>
<td>
<code>        </code><code>{</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>046</code></td>
<td>
<code>            </code><code>public</code> <code>int</code> <code>next(</code><code>final</code> <code>int</code> <code>pageOffset, </code><code>final</code> <code>int</code> <code>wordOffset, </code><code>final</code> <code>int</code> <code>pos)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>047</code></td>
<td>
<code>            </code><code>{</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>048</code></td>
<td>
<code>                </code><code>return</code> <code>(pos + PRIME_INC) &amp; ARRAY_MASK;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>049</code></td>
<td>
<code>            </code><code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>050</code></td>
<td>
<code>        </code><code>};</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>051</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>052</code></td>
<td>
<code>        </code><code>public</code> <code>abstract</code> <code>int</code> <code>next(</code><code>int</code> <code>pageOffset, </code><code>int</code> <code>wordOffset, </code><code>int</code> <code>pos);</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>053</code></td>
<td>
<code>    </code><code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>054</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>055</code></td>
<td>
<code>    </code><code>public</code> <code>static</code> <code>void</code> <code>main(</code><code>final</code> <code>String[] args)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>056</code></td>
<td>
<code>    </code><code>{</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>057</code></td>
<td>
<code>        </code><code>final</code> <code>StrideType strideType;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>058</code></td>
<td>
<code>        </code><code>switch</code> <code>(Integer.parseInt(args[</code><code>0</code><code>]))</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>059</code></td>
<td>
<code>        </code><code>{</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>060</code></td>
<td>
<code>            </code><code>case</code> <code>1</code><code>:</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>061</code></td>
<td>
<code>                </code><code>strideType = StrideType.LINEAR_WALK;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>062</code></td>
<td>
<code>                </code><code>break</code><code>;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>063</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>064</code></td>
<td>
<code>            </code><code>case</code> <code>2</code><code>:</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>065</code></td>
<td>
<code>                </code><code>strideType = StrideType.RANDOM_PAGE_WALK;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>066</code></td>
<td>
<code>                </code><code>break</code><code>;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>067</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>068</code></td>
<td>
<code>            </code><code>case</code> <code>3</code><code>:</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>069</code></td>
<td>
<code>                </code><code>strideType = StrideType.RANDOM_HEAP_WALK;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>070</code></td>
<td>
<code>                </code><code>break</code><code>;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>071</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>072</code></td>
<td>
<code>            </code><code>default</code><code>:</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>073</code></td>
<td>
<code>                </code><code>throw</code> <code>new</code> <code>IllegalArgumentException(</code><code>"Unknown StrideType"</code><code>);</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>074</code></td>
<td>
<code>        </code><code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>075</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>076</code></td>
<td>
<code>        </code><code>for</code> <code>(</code><code>int</code> <code>i = </code><code>0</code><code>; i &lt; </code><code>5</code><code>; i++)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>077</code></td>
<td>
<code>        </code><code>{</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>078</code></td>
<td>
<code>            </code><code>perfTest(i, strideType);</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>079</code></td>
<td>
<code>        </code><code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>080</code></td>
<td>
<code>    </code><code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>081</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>082</code></td>
<td>
<code>    </code><code>private</code> <code>static</code> <code>void</code> <code>perfTest(</code><code>final</code> <code>int</code> <code>runNumber, </code><code>final</code> <code>StrideType strideType)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>083</code></td>
<td>
<code>    </code><code>{</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>084</code></td>
<td>
<code>        </code><code>final</code> <code>long</code> <code>start = System.nanoTime();</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>085</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>086</code></td>
<td>
<code>        </code><code>int</code> <code>pos = -</code><code>1</code><code>;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>087</code></td>
<td>
<code>        </code><code>long</code> <code>result = </code><code>0</code><code>;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>088</code></td>
<td>
<code>        </code><code>for</code> <code>(</code><code>int</code> <code>pageOffset = </code><code>0</code><code>; pageOffset &lt; ARRAY_SIZE; pageOffset += WORDS_PER_PAGE)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>089</code></td>
<td>
<code>        </code><code>{</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>090</code></td>
<td>
<code>            </code><code>for</code> <code>(</code><code>int</code> <code>wordOffset = pageOffset, limit = pageOffset + WORDS_PER_PAGE;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>091</code></td>
<td>
<code>                 </code><code>wordOffset &lt; limit;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>092</code></td>
<td>
<code>                 </code><code>wordOffset++)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>093</code></td>
<td>
<code>            </code><code>{</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>094</code></td>
<td>
<code>                </code><code>pos = strideType.next(pageOffset, wordOffset, pos);</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>095</code></td>
<td>
<code>                </code><code>result += memory[pos];</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>096</code></td>
<td>
<code>            </code><code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>097</code></td>
<td>
<code>        </code><code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>098</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>099</code></td>
<td>
<code>        </code><code>final</code> <code>long</code> <code>duration = System.nanoTime() - start;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>100</code></td>
<td>
<code>        </code><code>final</code> <code>double</code> <code>nsOp = duration / (</code><code>double</code><code>)ARRAY_SIZE;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>101</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>102</code></td>
<td>
<code>        </code><code>if</code> <code>(208574349312L != result)</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>103</code></td>
<td>
<code>        </code><code>{</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>104</code></td>
<td>
<code>            </code><code>throw</code> <code>new</code> <code>IllegalStateException();</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>105</code></td>
<td>
<code>        </code><code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>106</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>107</code></td>
<td>
<code>        </code><code>System.out.format(</code><code>"%d - %.2fns %s\n"</code><code>,</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>108</code></td>
<td>
<code>                          </code><code>Integer.valueOf(runNumber),</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>109</code></td>
<td>
<code>                          </code><code>Double.valueOf(nsOp),</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>110</code></td>
<td>
<code>                          </code><code>strideType);</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>111</code></td>
<td>
<code>    </code><code>}</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>112</code></td>
<td><code>}</code></td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td></td>
</tr>
</tbody>
</table>
<p><b>Results</b></p>
<pre></pre>
<pre><code>Intel U4100 @ 1.3GHz, 4GB RAM DDR2 800MHz,
Windows 7 64-bit, Java 1.7.0_05
===========================================
0 - 2.38ns LINEAR_WALK
1 - 2.41ns LINEAR_WALK
2 - 2.35ns LINEAR_WALK
3 - 2.36ns LINEAR_WALK
4 - 2.39ns LINEAR_WALK

0 - 12.45ns RANDOM_PAGE_WALK
1 - 12.27ns RANDOM_PAGE_WALK
2 - 12.17ns RANDOM_PAGE_WALK
3 - 12.22ns RANDOM_PAGE_WALK
4 - 12.18ns RANDOM_PAGE_WALK

0 - 152.86ns RANDOM_HEAP_WALK
1 - 151.80ns RANDOM_HEAP_WALK
2 - 151.72ns RANDOM_HEAP_WALK
3 - 151.91ns RANDOM_HEAP_WALK
4 - 151.36ns RANDOM_HEAP_WALK

Intel i7-860 @ 2.8GHz, 8GB RAM DDR3 1333MHz,
Windows 7 64-bit, Java 1.7.0_05
=============================================
0 - 1.06ns LINEAR_WALK
1 - 1.05ns LINEAR_WALK
2 - 0.98ns LINEAR_WALK
3 - 1.00ns LINEAR_WALK
4 - 1.00ns LINEAR_WALK

0 - 3.80ns RANDOM_PAGE_WALK
1 - 3.85ns RANDOM_PAGE_WALK
2 - 3.79ns RANDOM_PAGE_WALK
3 - 3.65ns RANDOM_PAGE_WALK
4 - 3.64ns RANDOM_PAGE_WALK

0 - 30.04ns RANDOM_HEAP_WALK
1 - 29.05ns RANDOM_HEAP_WALK
2 - 29.14ns RANDOM_HEAP_WALK
3 - 28.88ns RANDOM_HEAP_WALK
4 - 29.57ns RANDOM_HEAP_WALK

Intel i7-2760QM @ 2.40GHz, 8GB RAM DDR3 1600MHz,
Linux 3.4.6 kernel 64-bit, Java 1.7.0_05
=================================================
0 - 0.91ns LINEAR_WALK
1 - 0.92ns LINEAR_WALK
2 - 0.88ns LINEAR_WALK
3 - 0.89ns LINEAR_WALK
4 - 0.89ns LINEAR_WALK

0 - 3.29ns RANDOM_PAGE_WALK
1 - 3.35ns RANDOM_PAGE_WALK
2 - 3.33ns RANDOM_PAGE_WALK
3 - 3.31ns RANDOM_PAGE_WALK
4 - 3.30ns RANDOM_PAGE_WALK

0 - 9.58ns RANDOM_HEAP_WALK
1 - 9.20ns RANDOM_HEAP_WALK
2 - 9.44ns RANDOM_HEAP_WALK
3 - 9.46ns RANDOM_HEAP_WALK
4 - 9.47ns RANDOM_HEAP_WALK</code></pre>
<p><b>Analysis</b></p>
<p>I ran the code on 3 different CPU architectures illustrating generational steps forward for Intel.  It is clear from the results that each generation has become progressively better at hiding the latency to main-memory based on the 3 bets described above for a relatively small heap.  This is because the size and sophistication of various caches keep improving.  However as memory size increases they become less effective.  For example, if the array is doubled to be 4GB in size, then the average latency increases from ~30ns to ~55ns for the i7-860 doing the random heap walk.It seems that for the linear walk case, memory latency does not exist.  However as we walk around memory in an evermore random pattern then the latency starts to become very apparent.</p>
<p>The random heap walk produced an interesting result.  This is a our worst case scenario, and given the hardware specifications of these systems, we could be looking at 150ns, 65ns, and 75ns for the above tests respectively based on memory controller and memory module latencies.  For the Nehalem (i7-860) I can further subvert the cache sub-system by using a 4GB array resulting in ~55ns on average per iteration.  The i7-2760QM has larger load buffers, TLB caches, and Linux is running with transparent huge pages which are all working to further hide the latency.  By playing with different prime numbers for the stride, results can vary wildly depending on processor type, e.g. try PRIME_INC = 39916801 for Nehalem.  I’d like to test this on a much larger heap with Sandy Bridge.The main take away is the more predictable the pattern of access to memory, then the better the cache sub-systems are at hiding main-memory latency.  Let’s look at these cache sub-systems in a little detail to try and understand the observed results.</p>
<p><b>Hardware Components</b></p>
<p>We have many layers of cache plus the pre-fetchers to consider for how latency gets hidden.  In this section I’ll try and cover the major components used to hide latency that our hardware and systems software friends have put in place.  We will investigate these latency hiding components and use the Linux <a href="https://perf.wiki.kernel.org/index.php/Tutorial" rel="external nofollow noreferrer">perf</a> and <a href="http://code.google.com/p/likwid/" rel="external nofollow noreferrer">Lightweight Performance Counters</a>utilities to retrieve the performance counters from our CPUs which tell how effective these components are when we execute our programs.  Performance counters are CPU specific and what I’ve used here are specific to Sandy Bridge.</p>
<p><b>Data Caches</b><br />
Processors typically have 2 or 3 layers of data cache.  Each layer as we move out is progressively larger with increasing latency.  The latest Intel processors have 3 layers (L1D, L2, and L3); with sizes 32KB, 256KB, and 4-30MB; and ~1ns, ~4ns, and ~15ns latency respectively for a 3.0GHz CPU.</p>
<p>Data caches are effectively hardware hash tables with a fixed number of slots for each hash value.  These slots are known as “ways”.  An 8-way associative cache will have 8 slots to hold values for addresses that hash to the same cache location.  Within these slots the data caches do not store words, they store cache-lines of multiple words.  For an Intel processor these cache-lines are typically 64-bytes, that is 8 words on a 64-bit machine.  This plays to the spatial bet that adjacent memory is likely to be required soon, which is typically the case if we think of arrays or fields of an object.</p>
<p>Data caches are typically evicted in a LRU manner.  Caches work by using a write-back algorithm were stores need only be propagated to main-memory when a modified cache-line is evicted.  This gives rise the the interesting phenomenon that a load can cause a write-back to the outer cache layers and eventually to main-memory.</p>
<pre></pre>
<pre><code>perf stat -e L1-dcache-loads,L1-dcache-load-misses java -Xmx4g TestMemoryAccessPatterns $

 Performance counter stats for 'java -Xmx4g TestMemoryAccessPatterns 1':
     1,496,626,053 L1-dcache-loads
       274,255,164 L1-dcache-misses
         #   18.32% of all L1-dcache hits

 Performance counter stats for 'java -Xmx4g TestMemoryAccessPatterns 2':
     1,537,057,965 L1-dcache-loads
     1,570,105,933 L1-dcache-misses
         #  102.15% of all L1-dcache hits 

 Performance counter stats for 'java -Xmx4g TestMemoryAccessPatterns 3':
     4,321,888,497 L1-dcache-loads
     1,780,223,433 L1-dcache-misses
         #   41.19% of all L1-dcache hits  

likwid-perfctr -C 2 -g L2CACHE java -Xmx4g TestMemoryAccessPatterns $

java -Xmx4g TestMemoryAccessPatterns 1
+-----------------------+-------------+
|         Event         |   core 2    |
+-----------------------+-------------+
|   INSTR_RETIRED_ANY   | 5.94918e+09 |
| CPU_CLK_UNHALTED_CORE | 5.15969e+09 |
| L2_TRANS_ALL_REQUESTS | 1.07252e+09 |
|     L2_RQSTS_MISS     | 3.25413e+08 |
+-----------------------+-------------+
+-----------------+-----------+
|     Metric      |  core 2   |
+-----------------+-----------+
|   Runtime [s]   |  2.15481  |
|       CPI       | 0.867293  |
| L2 request rate |  0.18028  |
|  L2 miss rate   | 0.0546988 |
|  L2 miss ratio  | 0.303409  |
+-----------------+-----------+
+------------------------+-------------+
|         Event          |   core 2    |
+------------------------+-------------+
| L3_LAT_CACHE_REFERENCE | 1.26545e+08 |
|   L3_LAT_CACHE_MISS    | 2.59059e+07 |
+------------------------+-------------+

java -Xmx4g TestMemoryAccessPatterns 2
+-----------------------+-------------+
|         Event         |   core 2    |
+-----------------------+-------------+
|   INSTR_RETIRED_ANY   | 1.48772e+10 |
| CPU_CLK_UNHALTED_CORE | 1.64712e+10 |
| L2_TRANS_ALL_REQUESTS | 3.41061e+09 |
|     L2_RQSTS_MISS     | 1.5547e+09  |
+-----------------------+-------------+
+-----------------+----------+
|     Metric      |  core 2  |
+-----------------+----------+
|   Runtime [s]   | 6.87876  |
|       CPI       | 1.10714  |
| L2 request rate | 0.22925  |
|  L2 miss rate   | 0.104502 |
|  L2 miss ratio  | 0.455843 |
+-----------------+----------+
+------------------------+-------------+
|         Event          |   core 2    |
+------------------------+-------------+
| L3_LAT_CACHE_REFERENCE | 1.52088e+09 |
|   L3_LAT_CACHE_MISS    | 1.72918e+08 |
+------------------------+-------------+

java -Xmx4g TestMemoryAccessPatterns 3
+-----------------------+-------------+
|         Event         |   core 2    |
+-----------------------+-------------+
|   INSTR_RETIRED_ANY   | 6.49533e+09 |
| CPU_CLK_UNHALTED_CORE | 4.18416e+10 |
| L2_TRANS_ALL_REQUESTS | 4.67488e+09 |
|     L2_RQSTS_MISS     | 1.43442e+09 |
+-----------------------+-------------+
+-----------------+----------+
|     Metric      |  core 2  |
+-----------------+----------+
|   Runtime [s]   |  17.474  |
|       CPI       |  6.4418  |
| L2 request rate | 0.71973  |
|  L2 miss rate   | 0.220838 |
|  L2 miss ratio  | 0.306835 |
+-----------------+----------+
+------------------------+-------------+
|         Event          |   core 2    |
+------------------------+-------------+
| L3_LAT_CACHE_REFERENCE | 1.40079e+09 |
|   L3_LAT_CACHE_MISS    | 1.34832e+09 |
+------------------------+-------------+</code></pre>
<p><b>Note</b>: The cache-miss rate of the combined L1D, L2 and L3 increases significantly as the pattern of access becomes more random.</p>
<p><b>Translation Lookaside Buffers (TLBs)</b><br />
Our programs deal with virtual memory addresses that need to be translated to physical memory addresses.  Virtual memory systems do this by mapping pages.  We need to know the offset for a given page and its size for any memory operation.  Typically page sizes are 4KB and are gradually moving to 2MB and greater.  Linux introduced <a href="http://lwn.net/Articles/423584/" rel="external nofollow noreferrer">Transparent Huge Pages</a> in the 2.6.38 kernel giving us 2MB pages.  The translation of virtual memory pages to physical pages is maintained by the <a href="http://en.wikipedia.org/wiki/Page_table" rel="external nofollow noreferrer">page table</a>.  This translation can require multiple accesses to the page table which is a huge performance penalty.  To accelerate this lookup, processors have a small hardware cache at each cache level called the TLB cache.  A miss on the TLB cache can be hugely expensive because the page table may not be in a nearby data cache.  By moving to larger pages, a TLB cache can cover a larger address range for the same number of entries.</p>
<pre></pre>
<pre><code>perf stat -e dTLB-loads,dTLB-load-misses java -Xmx4g TestMemoryAccessPatterns $

 Performance counter stats for 'java -Xmx4g TestMemoryAccessPatterns 1':
     1,496,128,634 dTLB-loads
           310,901 dTLB-misses
              #    0.02% of all dTLB cache hits 

 Performance counter stats for 'java -Xmx4g TestMemoryAccessPatterns 2':
     1,551,585,263 dTLB-loads
           340,230 dTLB-misses
              #    0.02% of all dTLB cache hits

 Performance counter stats for 'java -Xmx4g TestMemoryAccessPatterns 3':
     4,031,344,537 dTLB-loads
     1,345,807,418 dTLB-misses
              #   33.38% of all dTLB cache hits</code></pre>
<p><b>Note</b>: We only incur significant TLB misses when randomly walking the whole heap when huge pages are employed.</p>
<p><b>Hardware Pre-Fetchers</b><br />
Hardware will try and predict the next memory access our programs will make and speculatively load that memory into fill buffers.  This is done at it simplest level by pre-loading adjacent cache-lines for the spatial bet, or by recognising regular stride based access patterns, typically less than 2KB in stride length.  The tests below we are measuring the number of loads that hit a fill buffer from a hardware pre-fetch.</p>
<pre></pre>
<pre><code>likwid-perfctr -C 2 -g LOAD_HIT_PRE_HW_PF:PMC0 java -Xmx4g TestMemoryAccessPatterns $

java -Xmx4g TestMemoryAccessPatterns 1
+--------------------+-------------+
|       Event        |   core 2    |
+--------------------+-------------+
| LOAD_HIT_PRE_HW_PF | 1.31613e+09 |
+--------------------+-------------+

java -Xmx4g TestMemoryAccessPatterns 2
+--------------------+--------+
|       Event        | core 2 |
+--------------------+--------+
| LOAD_HIT_PRE_HW_PF | 368930 |
+--------------------+--------+

java -Xmx4g TestMemoryAccessPatterns 3
+--------------------+--------+
|       Event        | core 2 |
+--------------------+--------+
| LOAD_HIT_PRE_HW_PF | 324373 |
+--------------------+--------+</code></pre>
<p><b>Note</b>: We have a significant success rate for load hits with the pre-fetcher on the linear walk.</p>
<p><b>Memory Controllers and Row Buffers</b><br />
Beyond our last level cache (LLC) sits the memory controllers that manage access to the SDRAM banks.  Memory is organised into rows and columns.  To access an address, first the row address must be selected (RAS), then the column address is selected (CAS) within that row to get the word.  The row is typically a page in size and loaded into a row buffer.  Even at this stage the hardware is still helping hide the latency.  A queue of memory access requests is maintained and re-ordered so that multiple words can be fetched from the same row if possible.</p>
<p><b>Non-Uniform Memory Access (NUMA)</b><br />
Systems now have memory controllers on the CPU socket.  This move to on-socket memory controllers gave an ~50ns latency reduction over existing front side bus (FSB) and external <a href="http://en.wikipedia.org/wiki/Northbridge_(computing)" rel="external nofollow noreferrer">Northbridge</a> memory controllers.  Systems with multiple sockets employ memory interconnects, <a href="http://www.intel.com/content/www/us/en/io/quickpath-technology/quick-path-interconnect-introduction-paper.html" rel="external nofollow noreferrer">QPI</a> from Intel, which are used when one CPU wants to access memory managed by another CPU socket.  The presence of these interconnects gives rise to the non-uniform nature of server memory access.  In a 2-socket system memory may be local or 1 hop away.  On a 8-socket system memory can be up to 3 hops away, were each hop adds 20ns latency in each direction.</p>
<p><b>What does this mean for algorithms?</b></p>
<p>The difference between an L1D cache-hit, and a full miss resulting in main-memory access, is 2 orders of magnitude; i.e. &lt;1ns vs. 65-100ns.  If algorithms randomly walk around our ever increasing address spaces, then we are less likely to benefit from the hardware support that hides this latency.</p>
<p>Is there anything we can do about this when designing algorithms and data-structures?  Yes there is a lot we can do.  If we perform chunks of work on data that is co-located, and we stride around memory in a predictable fashion, then our algorithms can be many times faster.  For example rather than using bucket and chain <a href="http://en.wikipedia.org/wiki/Hash_table" rel="external nofollow noreferrer">hash tables</a>, like in the JDK, we can employ hash tables using open-addressing with linear-probing.  Rather than using linked-lists or trees with single items in each node, we can store an array of many items in each node.</p>
<p>Research is advancing on algorithmic approaches that work in harmony with cache sub-systems.  One area I find fascinating is <a href="http://en.wikipedia.org/wiki/Cache-oblivious_algorithm" rel="external nofollow noreferrer">Cache Oblivious Algorithms</a>.  The name is a bit misleading but there are some great concepts here for how to improve software performance and better execute in parallel.  This <a href="http://www.1024cores.net/home/parallel-computing/cache-oblivious-algorithms" rel="external nofollow noreferrer">article</a> is a great illustration of the performance benefits that can be gained.</p>
<p><b>Conclusion</b></p>
<p>To achieve great performance it is important to have sympathy for the cache sub-systems.  We have seen in this article what can be achieved by accessing memory in patterns which work with, rather than against, these caches.  When designing algorithms and data structures, it is now vitally important to consider cache-misses, probably even more so than counting steps in the algorithm.  This is not what we were taught in algorithm theory when studying computer science.  The last decade has seen some fundamental changes in technology.  For me the two most significant are the rise of multi-core, and now big-memory systems with 64-bit address spaces.</p>
<p>One thing is certain, if we want software to execute faster and scale better, we need to make better use of the many cores in our CPUs, and pay attention to memory access patterns.</p>
<p><b>Update: 06-August-2012</b><br />
Trying to design a random walk algorithm for all processors and memory sizes is tricky.  If I use the algorithm below then my Sandy Bridge processor is slower but the Nehalem is faster.  The point is performance will be <b>very</b>unpredictable when you walk around memory in a random fashion.  I’ve also included the L3 cache counters for more detail in all the tests.</p>
<table>
<tbody>
<tr>
<td>
<br />
<code>private</code> <code>static</code> <code>final</code> <code>long</code> <code>LARGE_PRIME_INC = 70368760954879L;</code></p>
<p><code>    </code><code>RANDOM_HEAP_WALK</code></p>
<p><code>    </code><code>{</code></p>
<p><code>        </code><code>public</code> <code>int</code> <code>next(</code><code>final</code> <code>int</code> <code>pageOffset, </code><code>final</code> <code>int</code> <code>wordOffset, </code><code>final</code> <code>int</code> <code>pos)</code></p>
<p><code>        </code><code>{</code></p>
<p><code>            </code><code>return</code> <code>(</code><code>int</code><code>)(pos + LARGE_PRIME_INC) &amp; ARRAY_MASK;</code></p>
<p><code>        </code><code>}</code></p>
<p><code>    </code><code>};<br />
</code><br />

</td>
</tr>
</tbody>
</table>
<pre></pre>
<pre><code>Intel i7-2760QM @ 2.40GHz, 8GB RAM DDR3 1600MHz,
Linux 3.4.6 kernel 64-bit, Java 1.7.0_05
=================================================
0 - 29.06ns RANDOM_HEAP_WALK
1 - 29.47ns RANDOM_HEAP_WALK
2 - 29.48ns RANDOM_HEAP_WALK
3 - 29.43ns RANDOM_HEAP_WALK
4 - 29.42ns RANDOM_HEAP_WALK

 Performance counter stats for 'java -Xmx4g TestMemoryAccessPatterns 3':
     9,444,928,682 dTLB-loads
     4,371,982,327 dTLB-misses
         #   46.29% of all dTLB cache hits 

     9,390,675,639 L1-dcache-loads
     1,471,647,016 L1-dcache-misses
         #   15.67% of all L1-dcache hits  

+-----------------------+-------------+
|         Event         |   core 2    |
+-----------------------+-------------+
|   INSTR_RETIRED_ANY   | 7.71171e+09 |
| CPU_CLK_UNHALTED_CORE | 1.31717e+11 |
| L2_TRANS_ALL_REQUESTS | 8.4912e+09  |
|     L2_RQSTS_MISS     | 2.79635e+09 |
+-----------------------+-------------+
+-----------------+----------+
|     Metric      |  core 2  |
+-----------------+----------+
|   Runtime [s]   | 55.0094  |
|       CPI       | 17.0801  |
| L2 request rate | 1.10108  |
|  L2 miss rate   | 0.362611 |
|  L2 miss ratio  | 0.329324 |
+-----------------+----------+
+--------------------+-------------+
|       Event        |   core 2    |
+--------------------+-------------+
| LOAD_HIT_PRE_HW_PF | 3.59509e+06 |
+--------------------+-------------+
+------------------------+-------------+
|        Event           |   core 2    |
+------------------------+-------------+
| L3_LAT_CACHE_REFERENCE | 1.30318e+09 |
| L3_LAT_CACHE_MISS      | 2.62346e+07 |
+------------------------+-------------+</code></pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-22 20:21:54</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Memory Access Patterns Are Important的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pmBGrBz.html" rel="bookmark">Uniform Memory Access</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				均匀访问模型(UMA): 高度的资源共享类型系统,提供直接的客户端到服务的通讯,并且客户端对远程服务具有详细的了解,又被称为紧耦合系统.在均匀访存模型中,所有的物理存储器被均匀共享,即处理器访问它们的时间是一样的.&amp;http://www.aliyun.com/zixun/aggregation/37954.html&quot;&gt;nbsp; (责任编辑:吕光)			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zeK3ENM.html" rel="bookmark">【OS】NMON的简介和使用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				[OS]NMON的简介和使用 目前NMON已开源,以sourceforge为根据地,网址是http://nmon.sourceforge.net. 1. 目的 本文介绍操作系统监控工具Nmon的概念.使用方式及使用参数.指导运维人员通过nmon工具监视AIX/Linux操作系统资源使用情况,收集监控结果及产生的数据文件,制作相关系统性能分析报告. 2. Nmon简介 Nmon (Nigel's Monitor)是由IBM 提供.免费监控 AIX 系统与 Linux 系统资源的工具.该工具可将服务			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKQDG5p.html" rel="bookmark">Understanding memory</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文http://careers.directi.com/display/tu/Understanding+and+optimizing+Memory+utilization Understanding page frames and pages Memory in Linux is organized in the form of pages (typically 4 KB in size). Contiguous linear addresses within a page are mapp			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b2PnEvp.html" rel="bookmark">Operating Principle and Implementation of Flink&colon; Memory Management</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Nowadays, open-source big data frameworks (such as Hadoop, Spark and Storm) all employ JVM, and Flink is one of them. JVM-based data analysis engines all need to store a large amount of data in the memory, so they have to address the following JVM is			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MydPeEb.html" rel="bookmark">Java Memory Model</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				[原文地址] The Java memory model specifies how the Java virtual machine works with the computer's memory (RAM). The Java virtual machine is a model of a whole computer so this model naturally includes a memory model - AKA the Java memory model. It is ver			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8j4WPb.html" rel="bookmark">提示access violation at address解决办法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 解决方法: 右击&quot;我的电脑&quot;.单击&quot;属性&quot;. 在&quot;系统属性&quot;中单击&quot;高级&quot;. 在&quot;性能&quot;中单击&quot;设置&quot;. 在&quot;性能选项&quot;中单击&quot;数据执行保护&quot;. 单击&quot;添加&quot;.选择要运行的程序. OK.就这么简单. Access Violation(非法访问)错误的解决方法 Access Violation(非法访问),General Pro			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MArdGKp.html" rel="bookmark">运行程序提示access violation at address的解决方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				现在把解决方法公布出来: 右击&quot;我的电脑&quot;.单击&quot;属性&quot;. 在&quot;系统属性&quot;中单击&quot;高级&quot;. 在&quot;性能&quot;中单击&quot;设置&quot;. 在&quot;性能选项&quot;中单击&quot;数据执行保护&quot;. 单击&quot;添加&quot;.选择要运行的程序. OK.就这么简单. Access Violation(非法访问)错误的解决方法 Access Violation(非法访问),Gener			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pP2NYvb.html" rel="bookmark">Linux内核同步机制之（三）：memory barrier【转】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转自:http://www.wowotech.net/kernel_synchronization/memory-barrier.html 一.前言 我记得以前上学的时候大家经常说的一个词汇叫做所见即所得,有些编程工具是所见即所得的,给程序员带来极大的方便.对于一个c程序员,我们的编写的代码能所见即所得吗?我们看到的c程序的逻辑是否就是最后CPU运行的结果呢?很遗憾,不是,我们的&quot;所见&quot;和最后的执行结果隔着: 1.编译器 2.CPU取指执行 编译器将符合人类思考的逻辑(c代码)翻译成了			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKkaoEb.html" rel="bookmark">The Query Optimizer</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				The Query Optimizer This chapter discusses SQL processing, optimization methods, and how the query optimizer (usually called the optimizer) chooses a specific plan to execute SQL. The chapter contains the following sections: Overview of the Query Opt			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMyvW4p.html" rel="bookmark" class="title">wps表格排序结果出现错误该怎么办&quest;</a>
					<div>
						  wps表格的排序功能是十分强大的,尤其是在处理大量数据,进行优选的时候,其作用尤为的突出.但是,有时候排序却会出现错误.让人无比的头大,那么wps表格排序的时候出现了错误,我们该怎样解决呢? 一. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/wzVgKkb.html" rel="bookmark" class="title">容易让站长忽视的四个重要seo优化问题</a>
					<div>
						比较常规的seo问题可能大家都很熟悉了,因为经常在文章中经常出现,说到网站的访问速度,我们就可以立马联想到网站的空间问题;谈到用户体验,我们立马就会想到站内的文章质量;说到关键词的排名,我们可能就会想 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXB2DWb.html" rel="bookmark" class="title">Unmi的Struts2学习笔记&lpar;三&rpar;</a>
					<div>
						连续几日熬夜,以致左胸又起闷痛感,何来如此辛苦?不由自忖,人生至今, 印象中从来就没有过安逸与幸福感.常要回避刺疼. 1. WebWork 的核心控制器是 ServletDispatcher,映射到  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJ7N4Vb.html" rel="bookmark" class="title">Linux 高级用户&comma;组和权限介绍</a>
					<div>
						  下面先来了解一下关于用户,组的四个文件 /etc/passwd /etc/shadow /etc/group /etc/gshadow 首先来了解一下/etc/passwd这个文件, 这个文件只是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOwBq3z.html" rel="bookmark" class="title">如何在 Excel 中执行公式计算</a>
					<div>
						早于 Microsoft Excel 2002 的 Excel 版本 在早于 Excel 2002 的版本的 Excel,公式计算基于工作表的工作表,从 Excel 工作簿的 Sheet1 开始执行. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYR3Wrp.html" rel="bookmark" class="title">如何快速重新启用U盘</a>
					<div>
						  在使用U盘的时候,当你点了&quot;安全删除硬件&quot;后并没有拔下U盘,突然又想要继续使用U盘,怎么办呢?相信你一定是先拔下再重新插入U盘吧.下面就教你一招更快的重新启用U盘的技巧. 利用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBKaKkM.html" rel="bookmark" class="title">db2 连接数 sql查询-sql查询db2数据库连接</a>
					<div>
						问题描述 sql查询db2数据库连接 小弟最近在做一个db2数据库的jdbc操作,期间需要用sql语句查询数据库的连接数,网上找了很久没找到,手头上没专业资料,还请知道的大哥大姐予以告知					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQrNQOM.html" rel="bookmark" class="title">cxf-CXF注解版怎么加入令牌</a>
					<div>
						问题描述 CXF注解版怎么加入令牌 代码 @Component @WebService(serviceName = &quot;HelloWorld&quot;,endpointInterface=& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1lj69b.html" rel="bookmark" class="title">&OpenCurlyDoubleQuote;视&rdquo;创未来，首届家庭实时视频产业联盟论坛呼吁共建产业生态</a>
					<div>
						5月11日下午,以&quot;视&quot;创未来为主题的首届家庭实时视频产业联盟论坛在深圳福田隆重召开.华为云核心网CaaS解决方案产品总监李德永表示,华为始终践行&quot;开放.合作.共赢&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZExYop.html" rel="bookmark" class="title">HTTP协议小结</a>
					<div>
						概述 HTTP超文本传输协议(Hypertext Transfer Protocol,简称HTTP)是应用层协议,自 1990 年起,HTTP 就已经被应用于 WWW 全球信息服务系统.它是无状态协议 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgVBqZb.html" rel="bookmark" class="title">关于一个DataSet如果循环录入数据</a>
					<div>
						问题描述 for(intj=0;j&lt;ds.Tables[0].Rows.Count;j++){ds2=db.select(&quot;select*fromUserInfomwhere(User ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba7aLXp.html" rel="bookmark" class="title">&lbrack;linux&rsqb;ubuntu下卸载openjdk并安装sunjdk</a>
					<div>
						在ubuntu软件安装软件中卸载掉openjdk并安装sunjdk后,使用java-version如下: ava version &quot;1.6.0_22&quot; OpenJDK Runtim ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjLj68p.html" rel="bookmark" class="title">MySQL的表分区</a>
					<div>
						一.什么是表分区 通俗地讲表分区是将一大表,根据条件分割成若干个小表.mysql5.1开始支持数据表分区了. 如:某用户表的记录超过了600万条,那么就可以根据入库日期将表分区,也可以根据所在地将表分 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7ZnEqp.html" rel="bookmark" class="title">手机上网：警惕流量&OpenCurlyDoubleQuote;黑洞&rdquo;</a>
					<div>
						本文讲的是手机上网:警惕流量&quot;黑洞&quot;, 前言 在&quot;2017年第二季度IT威胁演进&quot;研究报告中,我就发现在前20名移动恶意软件程序排名中,有几种常见的木马程序,都 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1rQ4xp.html" rel="bookmark" class="title">大数据金融谁是王者</a>
					<div>
						转眼间又到年底,互联网圈的各种盘点也纷至沓来.日前,中国科学院旗下的&lt;互联网周刊&gt;发布了&lt;2016互联网企业分类排行榜&gt;,对P2P.消费金融.互联网支付.大数据金融等互金类企业 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mx0ogRM.html" rel="bookmark" class="title">wcf-C&num;窗体程序调用WCF出错</a>
					<div>
						问题描述 C#窗体程序调用WCF出错 先写了一个WCF服务 ,发布到了IIS上,然后又创建一个窗体程序,添加引用服务的时候成功地把服务引了进来,可是在执行窗体程序的时候出错,提示&quot;在 Ser ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mx022RM.html" rel="bookmark" class="title">如何选择最佳的数据中心闪存？</a>
					<div>
						全闪存数据中心是个未来概念,同样还有不少方法实现数据中心内服务器或基于阵列的闪存存储. 你可以用闪存替换掉任何数据中心的存储系统,但应该这样吗? 现代数据中心的闪存存储设备范围广泛,包括完全闪存或基于 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M121e9p.html" rel="bookmark" class="title">jenkins-Jenkins新建项目配Repository URL验证不过，求大神指点迷津</a>
					<div>
						问题描述 Jenkins新建项目配Repository URL验证不过,求大神指点迷津 解决方案 http://ask.csdn.net/questions/165130					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDnPdrM.html" rel="bookmark" class="title">sql in关键字和结果集</a>
					<div>
						问题描述 sql in关键字和结果集 WORK :WID NO FINAL :WID FID RESOURCE:FID URL 通过NO找WID,通过WID找FID,通过FID找URL. 最后要显示出 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baBv8gM.html" rel="bookmark" class="title">nlb-网络加载平衡&lpar;NLB&rpar; 设置不成功</a>
					<div>
						问题描述 网络加载平衡(NLB) 设置不成功 我设置了NLB,但一直没ping不通cluster ip, 不知道为什么. cluster ip: 173.18.5.22 单播,port用的缺省值 ho ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRNZ5KM.html" rel="bookmark" class="title">arraylist-如下代码，循环打印出来为什么remove掉了4，而不是remove掉了3，求大神解释。</a>
					<div>
						问题描述 如下代码,循环打印出来为什么remove掉了4,而不是remove掉了3,求大神解释. List list=new ArrayList(); list.add(new ForTest(&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9x7NVb.html" rel="bookmark" class="title">新手，求助Nsis将网站打包成安装程序</a>
					<div>
						问题描述 RT,网站怎么打包啊,有高手会么?求指点 解决方案 解决方案二:大神召唤术~duangduangduang					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M60gZLz.html" rel="bookmark" class="title">中国航天大事：构建北斗卫星导航系统</a>
					<div>
						1994年,中国正式开始北斗卫星导航试验系统(北斗1号)的研制,并在2000年发射了两颗静止轨道卫星,区域性的导航功能得以实现.2003年又发射了一颗备份卫星,完成了北斗卫星导航试验系统的组建. 卫星 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bodkv3M.html" rel="bookmark" class="title">《区块链原理、设计与应用》一1&period;3　了不起的社会学实验</a>
					<div>
						1.3 了不起的社会学实验 1.比特币的诞生 2008 年 10 月 31 日,一位化名 Satoshi Nakamoto (中本聪) 的人在metzdowd 密码学邮件列表中提出了比特币(Bitco ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJqaWVp.html" rel="bookmark" class="title">苹果表示Apple不会追踪用户的定位</a>
					<div>
						摘要: 7月13日凌晨消息,针对CCTV曝光iPhone 手机 定位功能收集用户位置信息,涉嫌侵犯隐私的问题,苹果官方发布声明称,Apple不会追踪用户的定位:Apple 以前从未这样做过,以后也永远 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBkWydM.html" rel="bookmark" class="title">电子商务在创业者眼中已降温</a>
					<div>
						本报讯(记者 叶薇)虽然&quot;双十一&quot;http://www.aliyun.com/zixun/aggregation/7575.html&quot;&gt;电商促销创造了不少销售奇迹, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGrDYkp.html" rel="bookmark" class="title">sql server中怎么分配合同</a>
					<div>
						问题描述 sql server中怎么分配合同 解决方案 查询出所有可以分配的记录 变成乱序 循环分配,直到所有合同分配完毕 解决方案二: SQL Server 2005 中的同义词Failed to  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvYw3Vb.html" rel="bookmark" class="title">在Edi控件响应单击事件创建t对话框问题</a>
					<div>
						问题描述 在Edi控件响应单击事件创建t对话框问题 我在Edit控件中响应单击事件然后创建模态对话框,可是关闭模态对话框的时候程序就崩溃了 代码如下: BOOL CBolg1Dlg::PreTrans ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXdP2Kp.html" rel="bookmark" class="title">Unix发展史</a>
					<div>
						简述 了解过去,我们才能知其然,更知所以然.总结过去,我们才会知道明天该何去何从.在时间的滚轮中,许许多多的东西就像流星一样一闪而逝,而有些东西却能经受着时间的考验散发着经久的魅力,让人津津乐道.流传 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mrv2rvM.html" rel="bookmark" class="title">9月15日中国概念股全线下跌 搜狐跌8&period;17％</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 北京时间9月16日消息,据国外媒体报道,由于来自美国两大投资银行雷曼兄弟公司和美林公司的消息引起投资者的强烈担忧,美国股市周一出现暴跌.其中道琼斯工业平 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.040 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
